// Layout for a dimension card

<template>
  <div
    class="dimension-card d-inline-block card w-100"
    :class="{ clickable: isClickable }">
    <div class="card-body">
      <!-- Title -->
      <h3
        class="card-title pt-0 pt-md-2 pb-2 text-center"
        :class="{ 'mb-0': true }"
      >
        <slot name="title" />
      </h3>
      <!-- Score -->
      <h4
        v-if="!!$slots.score && identifier === 'scoring'"
        :class="{ 'mb-0': !$slots.default }"
        class="score pt-0 pb-0 pt-md-2 pb-md-2 text-center"
      >
        <slot
          name="score"
        >
          emptiness
        </slot>
      </h4>
      <!-- Description -->
      <p v-if="$slots.default" class="card-text">
        <!-- Default slot for description text -->
        <slot />
      </p>
    </div>
    <!-- Indicators -->
    <ul v-if="identifier !== 'scoring'" class="list-group list-group-flush">
      <dimensions-item-indicator
        v-for="(_, key) in indicators"
        :key="key"
        :indicator="$t(`message.dashboard.${identifier}.plots.title.${key}`)"
        :values="indicatorValues[key]" :filter-primary-value="indicators[key].primary"
        :display-name="indicators[key].displayName"
        class="list-group-item"
      />
    </ul>
  </div>
</template>

<script>
import DimensionsItemIndicator from './DimensionsItemIndicator'

export default {
  name: 'DimensionsItem',
  components: { DimensionsItemIndicator },
  props: {
    // Identifier for this card
    identifier: {
      type: String,
      default () {
        return ''
      }
    },
    // Metric values for all indicator for this card
    indicatorValues: {
      type: Object,
      default () {
        return {}
      }
    },
    /**
     * Indicator attributes e.g. human readable labels
     */
    indicators: {
      type: Object,
      default () {
        return {}
      }
    },
    isClickable: {
      type: Boolean,
      default: true
    }
  }
}
</script>

<style lang="scss" scoped>
@import "@/styles/metrics-style.scss";

.dimension-card {
  // Default background color to be overwritten
  background-color: $gray;
  color: rgba(white, 0.89);

  &.clickable {
    transition: transform .4s ease;

    &:hover {
    transition: transform .4s ease;
    transform: scale(1.01);
    }

    &::after {
      content: '';
      position: absolute;
      z-index: -1;
      top: 0;
      right: 0;
      bottom: 0;
      right: 0;
      width: 100%;
      height: 100%;
      transition: opacity .5s cubic-bezier(.25, .8, .25, 1);
      box-shadow: 0 12px 24px rgba(0, 0, 0, 0.25), 0 4px 8px rgba(0, 0, 0, 0.22);
      opacity: 0;
    }

    &:hover::after {
      opacity: 1;
    }
  }

  .list-group {
    .list-group-item {
      margin-bottom: -1px;
      border: 0;
      background: rgba(0, 0, 0, 0.12);
    }
  }

  .card-title {
    hyphens: auto;
  }
}

</style>
